Index: typo3/sysext/sv/reports/class.tx_sv_reports_serviceslist.php
===================================================================
--- typo3/sysext/sv/reports/class.tx_sv_reports_serviceslist.php	(revision 6501)
+++ typo3/sysext/sv/reports/class.tx_sv_reports_serviceslist.php	(working copy)
@@ -87,7 +87,7 @@
 		$services = $this->getInstalledServices();
 		$content .= '<table cellspacing="1" cellpadding="2" border="0" class="tx_sv_reportlist">';
 		foreach ($services as $serviceType => $installedServices) {
-			$content .= '<tr><td colspans="7">';
+			$content .= '<tr><td colspan="7">';
 			$content .= '<h4>' . sprintf($GLOBALS['LANG']->getLL('service_type'), $serviceType) . '</h4>';
 			$content .= '</td></tr>';
 			$content .= '<tr class="bgColor2">';
Index: typo3/sysext/reports/mod/index.php
===================================================================
--- typo3/sysext/reports/mod/index.php	(revision 6501)
+++ typo3/sysext/reports/mod/index.php	(working copy)
@@ -109,31 +109,29 @@
 				// Draw the form
 			$this->doc->form = '<form action="" method="post" enctype="multipart/form-data">';
 				// JavaScript
-			$this->doc->JScode = '
-				<script language="javascript" type="text/javascript">
-					script_ended = 0;
-					function jumpToUrl(URL) {
-						document.location = URL;
-					}
-					var state;
-					Event.observe(document, "dom:loaded", function(){
-						$$(".section-header").invoke("observe", "click", function(event){
-							var item = Event.element(event);
-							if (item.hasClassName("expanded")) {
-								item.removeClassName("expanded").addClassName("collapsed");
-								Effect.BlindUp(item.next("div"), {duration : 0.5});
-								state = 1;
-							} else {
-								item.removeClassName("collapsed").addClassName("expanded");
-								Effect.BlindDown(item.next("div"), {duration : 0.5});
-								state = 0;
-							}
-							new Ajax.Request("ajax.php", {
-								parameters : "ajaxID=Reports::saveCollapseState&item=" + item.id + "&state=" + state
-							});
+			$this->doc->JScodeArray[] = '
+				script_ended = 0;
+				function jumpToUrl(URL) {
+					document.location = URL;
+				}
+				var state;
+				Event.observe(document, "dom:loaded", function(){
+					$$(".section-header").invoke("observe", "click", function(event){
+						var item = Event.element(event);
+						if (item.hasClassName("expanded")) {
+							item.removeClassName("expanded").addClassName("collapsed");
+							Effect.BlindUp(item.next("div"), {duration : 0.5});
+							state = 1;
+						} else {
+							item.removeClassName("collapsed").addClassName("expanded");
+							Effect.BlindDown(item.next("div"), {duration : 0.5});
+							state = 0;
+						}
+						new Ajax.Request("ajax.php", {
+							parameters : "ajaxID=Reports::saveCollapseState&item=" + item.id + "&state=" + state
 						});
 					});
-				</script>
+				});
 			';
 			$this->doc->postCode='
 				<script language="javascript" type="text/javascript">
@@ -222,7 +220,7 @@
 		foreach ($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['reports'] as $extKey => $extensionReports) {
 			foreach ($extensionReports as $reportName => $report) {
 				$action = $extKey . '.' . $reportName;
-				$link = 'mod.php?M=tools_txreportsM1&SET[function]=' . $action;
+				$link = 'mod.php?M=tools_txreportsM1' . htmlspecialchars('&SET[function]=') . $action;
 
 				$reportTitle = $GLOBALS['LANG']->sL($report['title']);
 
@@ -236,7 +234,7 @@
 						$icon = $GLOBALS['BACK_PATH'] . '../' . str_replace(PATH_site, '', $absIconPath);
 					}
 				}
-				$icon = '<img' . t3lib_iconworks::skinImg($GLOBALS['BACK_PATH'], $icon, 'width="16" height="16"') . ' title="' . $reportTitle . '" />';
+				$icon = '<img' . t3lib_iconworks::skinImg($GLOBALS['BACK_PATH'], $icon, 'width="16" height="16"') . ' title="' . $reportTitle . '" alt="' . $reportTitle . '" />';
 				$reportContent  = '<dt><a href="' . $link . '">' . $icon . $reportTitle . '</a></dt>';
 				$reportContent .= '<dd>' . $GLOBALS['LANG']->sL($report['description']) . '</dd>';
 
Index: typo3/sysext/reports/reports/class.tx_reports_reports_status.php
===================================================================
--- typo3/sysext/reports/reports/class.tx_reports_reports_status.php	(revision 6501)
+++ typo3/sysext/reports/reports/class.tx_reports_reports_status.php	(working copy)
@@ -117,8 +117,8 @@
 				tx_reports_reports_status_Status::ERROR   => 'error',
 			);
 
-			$icon[tx_reports_reports_status_Status::WARNING] = '<img' . t3lib_iconWorks::skinImg($this->doc->backPath, 'gfx/warning.png', 'width="16" height="16"') . ' />';
-			$icon[tx_reports_reports_status_Status::ERROR] = '<img' . t3lib_iconWorks::skinImg($this->doc->backPath, 'gfx/error.png', 'width="16" height="16"') . ' />';
+			$icon[tx_reports_reports_status_Status::WARNING] = '<img' . t3lib_iconWorks::skinImg($this->doc->backPath, 'gfx/warning.png', 'width="16" height="16"') . ' alt="" />';
+			$icon[tx_reports_reports_status_Status::ERROR] = '<img' . t3lib_iconWorks::skinImg($this->doc->backPath, 'gfx/error.png', 'width="16" height="16"') . ' alt="" />';
 			$messages = '';
 			$headerIcon = '';
 			$sectionSeverity = 0;