Index: t3lib/stddb/tables.php
===================================================================
--- t3lib/stddb/tables.php	(revision 10381)
+++ t3lib/stddb/tables.php	(working copy)
@@ -403,6 +403,11 @@
 	'txt' => 'txt.gif',
 	'pdf' => 'pdf.gif',
 	'doc' => 'doc.gif',
+	'docm' => 'docm.gif',
+	'docx' => 'docx.gif',
+	'dot' => 'dot.gif',
+	'dotm' => 'dotm.gif',
+	'dotx' => 'dotx.gif',
 	'ai' => 'ai.gif',
 	'bmp' => 'bmp.gif',
 	'tif' => 'tif.gif',
@@ -424,7 +429,13 @@
 	'php5' => 'php3.gif',
 	'php6' => 'php3.gif',
 	'php' => 'php3.gif',
+	'potm' => 'potm.gif',
+	'potx' => 'potx.gif',
+	'pps' => 'pps.gif',
+	'ppsx' => 'ppsx.gif',
 	'ppt' => 'ppt.gif',
+	'pptm' => 'pptm.gif',
+	'pptx' => 'pptx.gif',
 	'ttf' => 'ttf.gif',
 	'pcx' => 'pcx.gif',
 	'png' => 'png.gif',
@@ -448,6 +459,10 @@
 	'ps' => 'ps.gif',
 	'tmpl' => 'tmpl.gif',
 	'xls' => 'xls.gif',
+	'xlsm' => 'xlsm.gif',
+	'xlsx' => 'xlsx.gif',
+	'xltm' => 'xltm.gif',
+	'xltx' => 'xltx.gif',
 	'fh3' => 'fh3.gif',
 	'inc' => 'inc.gif',
 	'mid' => 'mid.gif',
Index: typo3/gfx/fileicons/docm.gif
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: typo3\gfx\fileicons\docm.gif
___________________________________________________________________
Added: svn:mime-type
   + application/octet-stream

Index: typo3/gfx/fileicons/docx.gif
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: typo3\gfx\fileicons\docx.gif
___________________________________________________________________
Added: svn:mime-type
   + application/octet-stream

Index: typo3/gfx/fileicons/dot.gif
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: typo3\gfx\fileicons\dot.gif
___________________________________________________________________
Added: svn:mime-type
   + application/octet-stream

Index: typo3/gfx/fileicons/dotm.gif
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: typo3\gfx\fileicons\dotm.gif
___________________________________________________________________
Added: svn:mime-type
   + application/octet-stream

Index: typo3/gfx/fileicons/dotx.gif
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: typo3\gfx\fileicons\dotx.gif
___________________________________________________________________
Added: svn:mime-type
   + application/octet-stream

Index: typo3/gfx/fileicons/potm.gif
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: typo3\gfx\fileicons\potm.gif
___________________________________________________________________
Added: svn:mime-type
   + application/octet-stream

Index: typo3/gfx/fileicons/potx.gif
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: typo3\gfx\fileicons\potx.gif
___________________________________________________________________
Added: svn:mime-type
   + application/octet-stream

Index: typo3/gfx/fileicons/pps.gif
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: typo3\gfx\fileicons\pps.gif
___________________________________________________________________
Added: svn:mime-type
   + application/octet-stream

Index: typo3/gfx/fileicons/ppsx.gif
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: typo3\gfx\fileicons\ppsx.gif
___________________________________________________________________
Added: svn:mime-type
   + application/octet-stream

Index: typo3/gfx/fileicons/pptm.gif
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: typo3\gfx\fileicons\pptm.gif
___________________________________________________________________
Added: svn:mime-type
   + application/octet-stream

Index: typo3/gfx/fileicons/pptx.gif
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: typo3\gfx\fileicons\pptx.gif
___________________________________________________________________
Added: svn:mime-type
   + application/octet-stream

Index: typo3/gfx/fileicons/xlsm.gif
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: typo3\gfx\fileicons\xlsm.gif
___________________________________________________________________
Added: svn:mime-type
   + application/octet-stream

Index: typo3/gfx/fileicons/xlsx.gif
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: typo3\gfx\fileicons\xlsx.gif
___________________________________________________________________
Added: svn:mime-type
   + application/octet-stream

Index: typo3/gfx/fileicons/xltm.gif
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: typo3\gfx\fileicons\xltm.gif
___________________________________________________________________
Added: svn:mime-type
   + application/octet-stream

Index: typo3/gfx/fileicons/xltx.gif
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: typo3\gfx\fileicons\xltx.gif
___________________________________________________________________
Added: svn:mime-type
   + application/octet-stream