Index: typo3/sysext/cms/tslib/class.tslib_pagegen.php
===================================================================
--- typo3/sysext/cms/tslib/class.tslib_pagegen.php	(revision 6808)
+++ typo3/sysext/cms/tslib/class.tslib_pagegen.php	(working copy)
@@ -504,7 +504,15 @@
 			}
 			if (count($temp_styleLines)) {
 				if ($GLOBALS['TSFE']->config['config']['inlineStyle2TempFile']) {
-					$pageRenderer->addCssFile(TSpagegen::inline2TempFile(implode(chr(10), $temp_styleLines), 'css'));
+					$pageRenderer->addCssFile(
+						TSpagegen::inline2TempFile(implode(chr(10), $temp_styleLines), 'css'),
+						$GLOBALS['TSFE']->config['config']['inlineStyle2TempFile.']['alternate'] ? 'alternate stylesheet' : 'stylesheet',
+						$GLOBALS['TSFE']->config['config']['inlineStyle2TempFile.']['media'] ? $GLOBALS['TSFE']->config['config']['inlineStyle2TempFile.']['media'] : 'all',
+						$GLOBALS['TSFE']->config['config']['inlineStyle2TempFile.']['title'] ? $GLOBALS['TSFE']->config['config']['inlineStyle2TempFile.']['title'] : '',
+						$GLOBALS['TSFE']->config['config']['inlineStyle2TempFile.']['compress'] ? TRUE : FALSE,
+						$GLOBALS['TSFE']->config['config']['inlineStyle2TempFile.']['forceOnTop'] ? TRUE : FALSE,
+						$GLOBALS['TSFE']->config['config']['inlineStyle2TempFile.']['allWrap']
+					);
 				} else {
 					$pageRenderer->addCssInlineBlock('TSFEinlineStyle', implode(chr(10), $temp_styleLines));
 				}
@@ -514,7 +522,15 @@
 		if ($GLOBALS['TSFE']->pSetup['stylesheet']) {
 			$ss = $GLOBALS['TSFE']->tmpl->getFileName($GLOBALS['TSFE']->pSetup['stylesheet']);
 			if ($ss) {
-				$pageRenderer->addCssFile($ss);
+				$pageRenderer->addCssFile(
+					$ss,
+					$GLOBALS['TSFE']->pSetup['stylesheet.']['alternate'] ? 'alternate stylesheet' : 'stylesheet',
+					$GLOBALS['TSFE']->pSetup['stylesheet.']['media'] ? $GLOBALS['TSFE']->pSetup['stylesheet.']['media'] : 'all',
+					$GLOBALS['TSFE']->pSetup['stylesheet.']['title'] ? $GLOBALS['TSFE']->pSetup['stylesheet.']['title'] : '',
+					$GLOBALS['TSFE']->pSetup['stylesheet.']['compress'] ? TRUE : FALSE,
+					$GLOBALS['TSFE']->pSetup['stylesheet.']['forceOnTop'] ? TRUE : FALSE,
+					$GLOBALS['TSFE']->pSetup['stylesheet.']['allWrap']
+				);
 			}
 		}
 
@@ -545,12 +561,12 @@
 							$pageRenderer->addCssFile(
 								htmlspecialchars($ss),
 								$GLOBALS['TSFE']->pSetup['includeCSS.'][$key . '.']['alternate'] ? 'alternate stylesheet' : 'stylesheet',
-								$GLOBALS['TSFE']->pSetup['includeCSS.'][$key . '.']['media'] ? $GLOBALS['TSFE']->pSetup['includeCSS.'][$key . '.']['media'] : 'screen',
+								$GLOBALS['TSFE']->pSetup['includeCSS.'][$key . '.']['media'] ? $GLOBALS['TSFE']->pSetup['includeCSS.'][$key . '.']['media'] : 'all',
 								$GLOBALS['TSFE']->pSetup['includeCSS.'][$key . '.']['title'] ? $GLOBALS['TSFE']->pSetup['includeCSS.'][$key . '.']['title'] : '',
 								$GLOBALS['TSFE']->pSetup['includeCSS.'][$key . '.']['compress'] ? TRUE : FALSE,
 								$GLOBALS['TSFE']->pSetup['includeCSS.'][$key . '.']['forceOnTop'] ? TRUE : FALSE,
-								$GLOBALS['TSFE']->pSetup['includeCSS.'][$key . '.']['allWrap']);
-
+								$GLOBALS['TSFE']->pSetup['includeCSS.'][$key . '.']['allWrap']
+							);
 						}
 					}
 				}
@@ -633,7 +649,15 @@
 
 		if (trim($style)) {
 			if ($GLOBALS['TSFE']->config['config']['inlineStyle2TempFile']) {
-				$pageRenderer->addCssFile(TSpagegen::inline2TempFile($style, 'css'));
+				$pageRenderer->addCssFile(
+					TSpagegen::inline2TempFile($style, 'css'),
+					$GLOBALS['TSFE']->config['config']['inlineStyle2TempFile.']['alternate'] ? 'alternate stylesheet' : 'stylesheet',
+					$GLOBALS['TSFE']->config['config']['inlineStyle2TempFile.']['media'] ? $GLOBALS['TSFE']->config['config']['inlineStyle2TempFile.']['media'] : 'all',
+					$GLOBALS['TSFE']->config['config']['inlineStyle2TempFile.']['title'] ? $GLOBALS['TSFE']->config['config']['inlineStyle2TempFile.']['title'] : '',
+					$GLOBALS['TSFE']->config['config']['inlineStyle2TempFile.']['compress'] ? TRUE : FALSE,
+					$GLOBALS['TSFE']->config['config']['inlineStyle2TempFile.']['forceOnTop'] ? TRUE : FALSE,
+					$GLOBALS['TSFE']->config['config']['inlineStyle2TempFile.']['allWrap']
+				);
 			} else {
 				$pageRenderer->addCssInlineBlock('additionalTSFEInlineStyle', $style);
 			}